{--------------------------------------------------------------------}
{ Auteur  : Wim van der Vegt                                         }
{ Project : AVATAR Protocol Interpreter                              }
{--------------------------------------------------------------------}
{ ddmmyy:hhmm opmerking                                              }
{ 220891:2000 Creatie                                                }
{--------------------------------------------------------------------}
{ Nr.  To Do                                                         }
{  1.  Code Number of parameters for each ^V sequence                }
{--------------------------------------------------------------------}

PROGRAM AvtDisp;

USES
  Crt;

VAR
  fil     : FILE OF BYTE;
  i,
  ch,ch1  : BYTE;

CONST
  level = 0;
  raw   = TRUE;
  rl    : ARRAY[$00..$3F] OF BYTE = (0,1,0,0,0,0,0,0,2 {H},
                                     0,5,5,3,4,0,0 {O},
                                     0,1,0,3,1,2,6 {V},
                                     1,0,0,0,0,0,0 {FS},
                                     0,0,0 { },
                                     0,0,0,
                                     0,0,0,1,0,0,1,0,0,0,0,1,1 {0},
                                     1,0,0,0,0,0,0,0,0 {9},
                                     1,0,5,1,5,2);

PROCEDURE Get(VAR ch : BYTE);

BEGIN
  Read(fil,ch);
  IF (Chr(ch)=^P) AND NOT(raw)
    THEN
      BEGIN
        Read(fil,ch);
        ch:=ch AND $3F;
      END;
END; {of Get}

BEGIN
  textattr:=$07;
  Clrscr;
  Assign(fil,Paramstr(1)+'.avt');
  {$I-} Reset(fil); {$I+}
  WHILE (IOresult=0) AND NOT(eof(fil) OR Keypressed) DO
    BEGIN
      Get(ch);
      CASE Chr(ch) OF
        ^V : BEGIN
               Get(ch);
               Highvideo;
               Write('[^V');
               ch:=ch AND $3f;
               IF (ch<32)
                 THEN Write('^'+CHR(ch+64))
                 ELSE Write(Chr(ch));
               Lowvideo;
               IF ch<>Ord(^Y)
                 THEN For i:=1 TO rl[ch] DO
                   BEGIN
                     Get(ch1);
                     Write(ch1 AND $7F:4);
                   END
                 ELSE
                   BEGIN
                     Get(ch);
                     Write(ch:4,'x');
                     FOR i:=1 TO ch DO
                       BEGIN
                         Get(ch1);
                         Write(ch1 AND $7F:4);
                       END;
                   END;
               Highvideo;
               Write(']');
               Lowvideo;
             END;

        ^Y : BEGIN
               Highvideo;
               Write('[^Y');
               Lowvideo;
               Get(ch);
               Get(ch1);
               Write(ch1:4,'x',Chr(ch));
               Highvideo;
               Write(']');
               Lowvideo;
             END;

        ^H,
        ^L,
        ^I,
        ^G : BEGIN
               Highvideo;
               Write('[^',Chr(ch+64),']');
               Lowvideo;
             END;

        ELSE
          BEGIN
            IF (ch<32) AND NOT(Chr(ch) IN [#10,#13])
              THEN
                BEGIN
                  Write(#7'^'+CHR(ch+64));
                  Delay(1000);
                END
              ELSE Write(Chr(ch));
          END;
      END;
    END;
END.

